#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2400four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2400four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four24004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four24004xi = {
                1:'1010x-26y2176z',
                2:'1029x-1213y1796z',
                3:'1040x-718y2039z',
                4:'1070x-1572y1463z',
                5:'1076x-2112y375z',
                6:'1093x-673y2027z',
                7:'1103x-1171y1780z',
                8:'1145x-625y2014z',
                9:'1159x-1525y1444z',
                10:'1176x-1124y1764z',
                11:'1187x-2055y351z',
                12:'1194x-573y2001z',
                13:'122x-2329y563z',
                14:'1241x-517y1987z',
                15:'1246x-1072y1748z',
                16:'1247x-1473y1425z',
                17:'1285x-458y1974z',
                18:'1294x-1993y328z',
                19:'1314x-1016y1731z',
                20:'1326x-396y1960z',
                21:'1332x-1416y1406z',
                22:'1364x-330y1946z',
                23:'1380x-955y1714z',
                24:'1398x-262y1932z',
                25:'1399x-1925y304z',
                26:'1415x-1354y1386z',
                27:'1429x-191y1918z',
                28:'142x-108y2393z',
                29:'1443x-891y1697z',
                30:'1456x-117y1903z',
                31:'1480x-42y1888z',
                32:'1494x-1287y1366z',
                33:'1500x-1852y280z',
                34:'1502x-822y1680z',
                35:'1558x-750y1663z',
                36:'1570x-1216y1347z',
                37:'1596x-1773y256z',
                38:'1610x-674y1646z',
                39:'162x-460y2349z',
                40:'1642x-1139y1327z',
                41:'1659x-594y1628z',
                42:'167x-114y2391z',
                43:'1689x-1689y232z',
                44:'1703x-511y1611z',
                45:'1711x-1059y1307z',
                46:'1743x-425y1593z',
                47:'1776x-1599y209z',
                48:'1776x-974y1286z',
                49:'1779x-336y1575z',
                50:'1809x-244y1557z',
                51:'1835x-151y1538z',
                52:'1836x-885y1266z',
                53:'1856x-55y1520z',
                54:'1859x-1505y185z',
                55:'1891x-793y1246z',
                56:'1937x-1407y161z',
                57:'194x-118y2389z',
                58:'195x-472y2344z',
                59:'2009x-1304y137z',
                60:'2022x-726y1276z',
                61:'2076x-1198y113z',
                62:'2136x-1088y89z',
                63:'2191x-975y65z',
                64:'220x-119y2386z',
                65:'2240x-859y41z',
                66:'2282x-741y17z',
                67:'230x-483y2339z',
                68:'244x-2325y540z',
                69:'248x-117y2384z',
                70:'266x-490y2334z',
                71:'276x-113y2381z',
                72:'303x-496y2328z',
                73:'304x-107y2378z',
                74:'332x-97y2374z',
                75:'342x-498y2322z',
                76:'360x-85y2371z',
                77:'366x-2314y517z',
                78:'382x-498y2316z',
                79:'387x-71y2367z',
                80:'393x-955y2166z',
                81:'414x-53y2363z',
                82:'422x-495y2309z',
                83:'439x-33y2359z',
                84:'451x-952y2155z',
                85:'464x-11y2354z',
                86:'464x-489y2303z',
                87:'488x-2297y493z',
                88:'505x-480y2296z',
                89:'511x-946y2145z',
                90:'547x-468y2289z',
                91:'571x-936y2134z',
                92:'589x-452y2282z',
                93:'609x-2273y470z',
                94:'631x-434y2274z',
                95:'631x-923y2123z',
                96:'640x-1355y1873z',
                97:'672x-412y2266z',
                98:'691x-905y2112z',
                99:'712x-387y2258z',
                100:'719x-1336y1858z',
                101:'728x-2242y446z',
                102:'751x-884y2100z',
                103:'752x-359y2250z',
                104:'791x-328y2242z',
                105:'798x-1313y1843z',
                106:'811x-859y2088z',
                107:'828x-293y2233z',
                108:'846x-2205y423z',
                109:'863x-256y2224z',
                110:'870x-829y2076z',
                111:'876x-1284y1828z',
                112:'886x-1649y1501z',
                113:'897x-215y2215z',
                114:'928x-796y2064z',
                115:'929x-172y2205z',
                116:'953x-1251y1812z',
                117:'958x-126y2196z',
                118:'962x-2161y399z',
                119:'978x-1613y1482z',
                120:'985x-759y2052z',
                121:'986x-78y2186z'}
       
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400four4xi" usage = "target function for charge24004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2400four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2400FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2400FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four24004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four24004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four24004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2400FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2400four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    